"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var adbDriver = require('adb-driver');

global.regeneratorRuntime = require('@babel/runtime/regenerator');

var ADBCommander =
/*#__PURE__*/
function () {
  function ADBCommander() {
    _classCallCheck(this, ADBCommander);

    this.exec = adbDriver.exec;
  }
  /**
   * 构造调用adb命令的工具函数
   * @private
   * @returns {Promise.<{result: *, err: *}>}
   */


  _createClass(ADBCommander, [{
    key: "_commandFactory",
    value: function () {
      var _commandFactory2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(command) {
        var cmdResult;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.exec(command);

              case 2:
                cmdResult = _context.sent;

                if (!(cmdResult instanceof Error)) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", {
                  err: cmdResult
                });

              case 7:
                return _context.abrupt("return", {
                  result: cmdResult
                });

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _commandFactory(_x) {
        return _commandFactory2.apply(this, arguments);
      }

      return _commandFactory;
    }()
    /**
     * 获取设备列表
     * @returns {Promise.<{deviceList: *, err: *}>}
     */

  }, {
    key: "deviceList",
    value: function () {
      var _deviceList = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref, result, err, _parseDeviceInfo;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _parseDeviceInfo = function _ref2(stdout) {
                  if (!stdout) {
                    return [];
                  }

                  var lines = stdout.replace(/(\n|\r\n){1,}/g, '\n').split('\n');
                  var result = lines.filter(function (item, idx) {
                    var oneDevice = item.split('\t');
                    return idx !== 0 && oneDevice[1] === 'device';
                  }).map(function (item) {
                    return item.split('\t')[0];
                  });
                  return result;
                };

                _context2.next = 3;
                return this._commandFactory("adb devices");

              case 3:
                _ref = _context2.sent;
                result = _ref.result;
                err = _ref.err;
                return _context2.abrupt("return", {
                  deviceList: _parseDeviceInfo(result),
                  err: err
                  /**
                   * 解析设备原始信息为数组信息;
                   * @private
                   */

                });

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function deviceList() {
        return _deviceList.apply(this, arguments);
      }

      return deviceList;
    }()
    /**
     * 建立adb reverse设定
     * @param deviceSN 设备sn号
     * @param localPort 本地端口
     * @param remotePort 远程端口
     * @returns {Promise.<{result: *, err: *}>}
     */

  }, {
    key: "reverse",
    value: function () {
      var _reverse = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(deviceSN, localPort, remotePort) {
        var cmd;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                cmd = "adb -s ".concat(deviceSN, " reverse tcp:").concat(remotePort, " tcp:").concat(localPort);
                _context3.next = 3;
                return this._commandFactory(cmd);

              case 3:
                return _context3.abrupt("return", _context3.sent);

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function reverse(_x2, _x3, _x4) {
        return _reverse.apply(this, arguments);
      }

      return reverse;
    }()
    /**
     * 建立adb reverse设定
     * @param deviceSN 设备sn号
     * @param localPort 本地端口
     * @param remotePort 远程端口
     * @returns {Promise.<{result: *, err: *}>}
     */

  }, {
    key: "forward",
    value: function () {
      var _forward = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(deviceSN, localPort, remotePort) {
        var cmd;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                cmd = "adb -s ".concat(deviceSN, " forward tcp:").concat(localPort, " tcp:").concat(remotePort);
                _context4.next = 3;
                return this._commandFactory(cmd);

              case 3:
                return _context4.abrupt("return", _context4.sent);

              case 4:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function forward(_x5, _x6, _x7) {
        return _forward.apply(this, arguments);
      }

      return forward;
    }()
    /**
     * 返回adb version信息
     * @returns {Promise.<{version: *, err: *}>}
     */

  }, {
    key: "version",
    value: function () {
      var _version = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5() {
        var _ref3, result, err;

        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._commandFactory("adb version");

              case 2:
                _ref3 = _context5.sent;
                result = _ref3.result;
                err = _ref3.err;
                return _context5.abrupt("return", {
                  version: result,
                  err: err
                });

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function version() {
        return _version.apply(this, arguments);
      }

      return version;
    }()
    /**
     * 输出adb命令的执行结果
     * @param cmd
     * @returns {Promise.<void>}
     */

  }, {
    key: "print",
    value: function () {
      var _print = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(cmd) {
        var _ref4, result, err;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._commandFactory(cmd);

              case 2:
                _ref4 = _context6.sent;
                result = _ref4.result;
                err = _ref4.err;

                if (err) {
                  console.error("### App Server ### print(): adb error: ".concat(err.message));
                }

              case 6:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function print(_x8) {
        return _print.apply(this, arguments);
      }

      return print;
    }()
    /**
     * 卸载
     * @param deviceSN 设备sn号
     * @param pkg apk 包名
     * @returns {Promise.<{result: *, err: *}>}
     */

  }, {
    key: "uninstall",
    value: function () {
      var _uninstall = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(deviceSN, pkg) {
        var _ref5, result, err;

        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this._commandFactory("adb -s ".concat(deviceSN, " uninstall ").concat(pkg));

              case 2:
                _ref5 = _context7.sent;
                result = _ref5.result;
                err = _ref5.err;
                return _context7.abrupt("return", {
                  result: result,
                  err: err
                });

              case 6:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function uninstall(_x9, _x10) {
        return _uninstall.apply(this, arguments);
      }

      return uninstall;
    }()
    /**
     * 安装apk
     * @param deviceSN 设备sn号
     * @param apkPath apk文件路径
     * @returns {Promise.<{result: *, err: *}>}
     */

  }, {
    key: "install",
    value: function () {
      var _install = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee8(deviceSN, apkPath) {
        var _ref6, result, err;

        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this._commandFactory("adb -s ".concat(deviceSN, " install ").concat(apkPath));

              case 2:
                _ref6 = _context8.sent;
                result = _ref6.result;
                err = _ref6.err;
                return _context8.abrupt("return", {
                  result: result,
                  err: err
                });

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function install(_x11, _x12) {
        return _install.apply(this, arguments);
      }

      return install;
    }()
    /**
     * 判断设备是否安装
     * @param deviceSN 设备sn号
     * @param pkg 包名
     * @returns {Promise.<{isInstalled: *, err: *}>}
     */

  }, {
    key: "isInstalled",
    value: function () {
      var _isInstalled = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee9(deviceSN, pkg) {
        var _ref7, result, err, isInstalled;

        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this._commandFactory("adb -s ".concat(deviceSN, " shell pm path ").concat(pkg));

              case 2:
                _ref7 = _context9.sent;
                result = _ref7.result;
                err = _ref7.err;
                isInstalled = false;

                if (result && result.indexOf('package:') > -1) {
                  isInstalled = true;
                }

                return _context9.abrupt("return", {
                  isInstalled: isInstalled,
                  err: err
                });

              case 8:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function isInstalled(_x13, _x14) {
        return _isInstalled.apply(this, arguments);
      }

      return isInstalled;
    }()
    /**
     * 启动Activity
     *
     * @param deviceSN 设备sn号
     * @param action(可选) 指定Intent action
     * @param component(可选) 指定组件名
     * @param extra(可选) [{key, type, value}...] Extra参数
     * @returns {Promise.<void>}
     */

  }, {
    key: "startActivity",
    value: function () {
      var _startActivity = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee10(deviceSN, action, component, extra) {
        var commandArray, parseExtra, _ref8, result, err;

        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                parseExtra = function _ref9(extra) {
                  var typeMap = {
                    'string': '--es',
                    'null': '--esn',
                    'boolean': '--ez',
                    'int': '--ei',
                    'float': '--ef',
                    'uri': '--eu',
                    'component': '--ecn',
                    'String[]': '--esa',
                    'int[]': '--eia',
                    'long[]': '--ela',
                    'float[]': '--efa'
                  };
                  var extraCommands = [];
                  extra.forEach(function (item) {
                    if (item.type in typeMap) {
                      extraCommands.push(typeMap[item.type]);
                      extraCommands.push(item.key);

                      if (item.type.endsWith('[]')) {
                        extraCommands.push(item.value.join(','));
                      } else {
                        extraCommands.push(item.value);
                      }
                    }
                  });
                  return extraCommands;
                };

                commandArray = [];
                commandArray.push('adb', '-s', deviceSN, 'shell', 'am', 'start');

                if (action !== undefined) {
                  commandArray.push('-a', action);
                }

                if (component !== undefined) {
                  commandArray.push('-n', component);
                }

                if (extra) {
                  commandArray.push(parseExtra(extra).join(' '));
                }

                console.log('command: ', commandArray.join(' '));
                _context10.next = 9;
                return this._commandFactory(commandArray.join(' '));

              case 9:
                _ref8 = _context10.sent;
                result = _ref8.result;
                err = _ref8.err;
                return _context10.abrupt("return", {
                  result: result,
                  err: err
                });

              case 13:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function startActivity(_x15, _x16, _x17, _x18) {
        return _startActivity.apply(this, arguments);
      }

      return startActivity;
    }()
    /**
     * 执行adb命令
     *
     * @param command adb command
     * @returns {Promise.<{result: *, err: *}>}
     */

  }, {
    key: "exeCommand",
    value: function () {
      var _exeCommand = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee11(command) {
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this._commandFactory(command);

              case 2:
                return _context11.abrupt("return", _context11.sent);

              case 3:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function exeCommand(_x19) {
        return _exeCommand.apply(this, arguments);
      }

      return exeCommand;
    }()
  }]);

  return ADBCommander;
}();

module.exports = ADBCommander;